/* Copyright 2008 Gentoo Foundation
 * Distributed under the terms of the GNU General Public License v2
 * Author: Michael Haubenwallner <haubi@gentoo.org>
 */

#ifndef _aixdll_Dependency_h
#define _aixdll_Dependency_h

#include <string>

#include "SearchPath.h"

namespace aixdll {

class Dependency : virtual public RefCounted
{
public:
	~Dependency() {}

	Dependency()
	  : name_(0)
	  , key_(0)
	  , provider_(0)
	{}

	Dependency(ObjectNamePtr name)
	  : name_(name)
	  , key_(0)
	  , provider_(0)
	{}

	Dependency(ObjectKeyPtr key)
		: name_(0)
		, key_(key)
		, provider_(0)
	{}

	ObjectNamePtr const& name() const { return name_; }
	ObjectKeyPtr const& key() const { return key_; }

	ObjectPtr provider() const { return provider_; }
	void setProvider(ObjectPtr provider) { provider_ = provider; }

private:
	ObjectNamePtr   name_;
	ObjectKeyPtr    key_;
	ObjectPtr       provider_;
};

typedef SmartPtr<Dependency> DependencyPtr;

}

#endif /* _aixdll_Dependency_h */
