/* Copyright 2008 Gentoo Foundation
 * Distributed under the terms of the GNU General Public License v2
 * Author: Michael Haubenwallner <haubi@gentoo.org>
 */

#ifndef _aixdll_ObjectReader_h
#define _aixdll_ObjectReader_h

#include <map>
#include <string>

#include "SharedObject.h"
#include "StaticObject.h"

namespace aixdll {

class ObjectReader {
public:
	typedef std::vector<ObjectPtr> ObjectContainer;

	~ObjectReader() {}
	ObjectReader() : objectCache_(), libraryMemberCache_() {}

	int readObjects(std::string const& filename
		, std::string const& identifier
		, ObjectContainer& out
	);
private:
	class Dumper;
	void parseRunpathDeplibs(Dumper *dumper, SharedObjectPtr &object) const;

	std::map<std::string, ObjectPtr> objectCache_;
	std::map<std::string, bool> brokenFilesCache_;

	typedef std::vector<std::string> LibraryMemberNameContainer;
	typedef std::map<std::string, LibraryMemberNameContainer> LibraryMemberCache;
	LibraryMemberCache libraryMemberCache_;
};

}

#endif /* _aixdll_ObjectReader_h */
